//
// Created by tim on 05.04.23.
//

#ifndef CTUAPEX_CTUAPEXCONSUMER_H
#define CTUAPEX_CTUAPEXCONSUMER_H

#include <clang/AST/ASTConsumer.h>
#include <spdlog/spdlog.h>
#include <utility>
#include "Callgraph.h"
#include "ExtractionMetadata.h"
#include "clang/Lex/Lexer.h"
#include "GlobalsMarker.h"
#include "CTUApexAction.h"
#include "ExtractionBlock.h"


class CTUApexConsumer : public clang::ASTConsumer {
public:
    explicit CTUApexConsumer(metacg::Callgraph *call_graph, std::vector<ExtractionBlock> &includes,
                             std::vector<ExtractionBlock> &macros, std::vector<ExtractionBlock>& pragmas)
            : call_graph(call_graph), includes(includes), macros(macros), pragmas(pragmas) {
    }


    void outlineFunctions();
    void outlineGlobals();

    std::string mergeSorted();

    virtual void HandleTranslationUnit(clang::ASTContext &Context);

private:

    std::vector<ExtractionBlock> funcs;
    std::vector<ExtractionBlock> globals;

    std::vector<clang::CallExpr *> calls;
    // not owned
    metacg::Callgraph *call_graph;
    std::vector<ExtractionBlock>& includes;
    std::vector<ExtractionBlock>& macros;
    std::vector<ExtractionBlock>& pragmas;

    ExtractionBlock getNextExtractionBlock();

    void getAvailableFunctions(metacg::Callgraph callgraph);

    void filterExtrationBlocks();
};

#endif //CTUAPEX_CTUAPEXCONSUMER_H
