//
// Created by tim on 28.11.24.
//

#ifndef CTUAPEX_COMMANDLINEARGS_H
#define CTUAPEX_COMMANDLINEARGS_H
#include <clang/Tooling/CommonOptionsParser.h>
using namespace llvm;
//Die commandozeilen optionen die wir parsen wollen, gehören zu unserem program
static cl::OptionCategory CTUApex("Cross Translation Unit App Extraction");

static cl::opt<std::string> cg_file("cg-file", cl::desc("MetaCG file containing a whole programm call graph"),
                                    cl::value_desc("filename"), cl::Required, cl::cat(CTUApex));

enum class LogLevel {
    Trace, Debug, Info, Warning, Error, /* Critical,*/ Off
};

static cl::list<std::string> extractionPoints("extract",
                                              cl::desc("Qualified names of the function to start the extraction from"),
                                              cl::value_desc("Comma separated list of function names"), cl::Optional,
                                              cl::cat(CTUApex));

static cl::opt<LogLevel> LoggingLevel("log-level", cl::desc("Select log level"),
                                      cl::values(clEnumValN(LogLevel::Trace, "trace", "Enable Trace and higher logs"),
                                                 clEnumValN(LogLevel::Debug, "debug", "Enable Debug and higher logs"),
                                                 clEnumValN(LogLevel::Info, "info", "Enable Info and higher logs"),
                                                 clEnumValN(LogLevel::Warning, "warning",
                                                            "Enable Warning and higher logs"),
                                                 clEnumValN(LogLevel::Error, "error", "Enable only Error logs"),
                                                 clEnumValN(LogLevel::Off, "off", "Disable all logging")),
                                      cl::init(LogLevel::Info), cl::cat(CTUApex));

static cl::opt<bool> OnlyWrapper("generate-only-wrapper", cl::desc("Output only the wrapper function"),
                                 cl::cat(CTUApex));

#endif //CTUAPEX_COMMANDLINEARGS_H
