//
// Created by tim on 27.07.23.
//

#ifndef CTUAPEX_GLOBALSMARKER_H
#define CTUAPEX_GLOBALSMARKER_H


#include "clang/AST/RecursiveASTVisitor.h"
#include "unordered_set"

/**
 * Class to get all accessed types and accessed global vars in a function
 */
class GlobalsMarker : public clang::RecursiveASTVisitor<GlobalsMarker> {
public:

    //Todo: maybe constify
    std::unordered_set<clang::Decl *> outlineStore = {};

    /// Check if it is access to a global variable
    bool VisitDeclRefExpr(clang::DeclRefExpr *decl_ref);

    /// Handles all the types encountered
    bool VisitType(clang::Type *t);

    bool shouldWalkTypesOfTypeLocs() const { return true; }

    bool shouldVisitTemplateInstantiations() const { return true; }

    /**
     *  Walks over a function declaration and returns the directly referenced nodes which should be kept
     * @param func_decl The function declaration to walk over
     * @return Directly referenced nodes
     */
    std::unordered_set<clang::Decl *> get_nodes_to_outline(clang::FunctionDecl *func_decl);
};

#endif //CTUAPEX_GLOBALSMARKER_H
