GNU nano 2.9.8 setup.sh

#!/bin/bash
set -e

ml purge
ml gcc/11
ml clang/14
#get MetaCG from repo
git clone git@git.rwth-aachen.de:tuda-sc/projects/metacg.git
cd metacg

#build and install metacg dependency for cg validate
mkdir -p deps/install
cd deps
wget http://apps.fz-juelich.de/scalasca/releases/cube/4.5/dist/cubelib-4.5.tar.gz
mkdir cubelib
cd cubelib
tar xzf ../cubelib-4.5.tar.gz
cd cubelib-4.5
./configure --prefix=$(realpath ../../install/cubelib)
make install -j 64

#install metacg graph lib and tools
cd ../../../
mkdir build
mkdir install
cd build
cmake -G "Unix Makefiles" -DCMAKE_EXPORT_COMPILE_COMMANDS=ON -DMETACG_BUILD_CGCOLLECTOR=ON \
 -DCUBE_LIB=$(realpath ../deps/install/cubelib/lib) -DCUBE_INCLUDE=$(realpath ../deps/install/cubelib/include/cubelib) \
 -DCMAKE_INSTALL_PREFIX=$(realpath ../install) ..

make install -j 64

cd ../..

ml purge
ml gcc/11
ml clang/15

git clone git@git.rwth-aachen.de:tim.heldmann/CTUApex.git
cd CTUApex
mkdir build
cd build
cmake -Dmetacg_DIR=$(realpath ../../metacg/install/lib/cmake/metacg) \
 -Dspdlog_DIR=$(realpath ../../metacg/install/lib/cmake/spdlog) -DCMAKE_EXPORT_COMPILE_COMMANDS=ON ..
make -j 64
