//
// Created by mority on 5/14/20.
//

#include <stdio.h>
#include <stdlib.h>
#include "matrix_mult.h"

#define MAX_ITER 10000
#define MOD 7

int main(void) {
	// matrix dimensions, must be quadratic
	int m = 100;
	int n = 100;

	// read matrix A from file
	FILE * fp = fopen("data/matrixOne.txt", "r");
	int ** A = (int **) malloc(m*sizeof(int*));
	for(int i = 0; i < m; ++i) {
		A[i] = (int *) malloc(n*sizeof(int));
	}
    MatrixCalc matrixCalc;
    matrixCalc.read_matrix(fp, A, m, n);
	fclose(fp);

	// read matrix B from file
	fp = fopen("data/matrixTwo.txt", "r");
	int ** B = (int **) malloc(m*sizeof(int*));
	for(int i = 0; i < m; ++i) {
		B[i] = (int *) malloc(n*sizeof(int));
	}
    matrixCalc.read_matrix(fp, B, m, n);
	fclose(fp);

	// allocate matrix C
	int ** C = (int **) malloc(m*sizeof(int*));
	for(int i = 0; i < m; ++i) {
		C[i] = (int *) malloc(n*sizeof(int));
	}

  // TODO mini-cpr pre-compute checkpoint location

	// main loop
	for(int i = 0; i < MAX_ITER; ++i) {

        matrixCalc.kernel_step1(A, m, n, B, m, n, C, MOD);

        matrixCalc.kernel_step2(A, m, n, B, m, n, C, MOD);

        matrixCalc.kernel_step3(A, m, n, B, m, n, C, MOD);

	}

  // TODO mini-cpr post-compute checkpoint location

	// write result to file
	fp = fopen("data/matrixResult.txt", "w");
    matrixCalc.write_matrix(fp, B, m, n);
	fclose(fp);

	// clean up
	for(int i = 0; i < m; ++i) {
		free(A[i]);
		free(B[i]);
		free(C[i]);
	}
	free(A);
	free(B);
	free(C);
}
