//
// Created by tim on 03.12.24.
//

#include "geometry.h"
#include "macros.h"

// Namespace
namespace Geometry {


    Point::Point(int x, int y) : x(x), y(y) {}


    // Base class for Virtual Inheritance
    void Shape::draw() const { std::cout << "Drawing shape" << std::endl; }

    // Derived class from TwoDimensionalShape

    Circle::Circle(int x, int y, double r) : center(x, y), radius(r) {}

    // Overriding virtual functions
    void Circle::draw() const {
        std::cout << "Drawing circle at (" << center.x << ", " << center.y << ") with radius " << radius
                  << std::endl;
    }

    double Circle::area() const { return PI * radius * radius; }

    double Circle::perimeter() const { return 2 * PI * radius; }


    // Constructor Overloading
    Circle::Circle(double r) : center(0, 0), radius(r) {}

    // Function Overloading
    void Circle::setRadius(double r) { radius = r; }

    void Circle::setRadius(int r) { radius = static_cast<double>(r); }
    //}

    // Static and Non-static Variables


    Counter::Counter() : nonStaticCount(0) {}

    void Counter::increment() {
        staticCount++;
        nonStaticCount++;
    }

    void Counter::reset() { staticCount = 0; }

    int Counter::staticCount = 0;
void printShape(const Shape &shape) {
    shape.draw();
}

};
